Subject: Re: linux-next: build failure after merge of the thunderbolt tree

From: Mika Westerberg <[email-masked]>
Date: Mon, 10 Aug 2020 13:12:30 +0300

Hi all,

On Mon, Aug 10, 2020 at 09:10:53AM +1000, Stephen Rothwell wrote:
> Hi Linus,
> 
> On Sun, 9 Aug 2020 11:04:28 -0700 Linus Torvalds <[email-masked]> wrote:
> >
> > On Sun, Aug 9, 2020 at 1:19 AM Stephen Rothwell <[email-masked]> wrote:
> > >
> > > I looks like the above report got lost along the way to you :-(  
> > 
> > Hmm. Why didn't I see this as a build failure?
> > 
> > Oh. Because the USB4_KUNIT_TEST stuff requires everything to be built
> > in. And I have them as modules.
> 
> Yeah, I only saw it because I do an allyesconfig build late in my day.

Sorry about this. I was not sure how to deal with this as Thunderbolt
goes through Greg's USB tree, so I just ended up mentioning it in my
pull request without actually including the complete patch.

The reason for the built in dependency is that KUnit adds its own
module_init() in kunit_test_suite() so that causes linker error since
the TBT driver does the same. I guess the better alternative would be to
not use kunit_test_suite() and instead make calls to
__kunit_test_suites_init() and __kunit_test_suites_exit() in the
driver's nhi_init()/nhi_exit().

> > > Here's the patch in case you want to directly apply it:  
> > 
> > Will do. Thanks,
> 
> Thanks.

Thanks!